using LifeLogApp.Services;
using LifeLogApp.ViewModel;
using Microsoft.Maui.Controls.Maps;
using Microsoft.Maui.Maps;

namespace LifeLogApp;

public partial class CapturePage : ContentPage
{
    readonly Serilog.ILogger logger;

    public CapturePage(Serilog.ILogger logger, MainViewModel vm)
    {
        this.logger = logger;

        InitializeComponent();

        BindingContext = vm;

        Task.Run(async () =>
        {
            var firstMoveIsDone = false;

            while (true)
            {
                if (vm.CurrentLocation != null)
                {
                    if (!firstMoveIsDone)
                    {
                        await MainThread.InvokeOnMainThreadAsync(async () =>
                        {
                            MapSpan mapSpanFirst = MapSpan.FromCenterAndRadius(map.VisibleRegion.Center,
                                   Distance.FromMeters(120));
                            map.MoveToRegion(mapSpanFirst);

                            //Pin pin = new Pin
                            //{
                            //    Label = "Label",
                            //    Address = "Address",
                            //    Type = PinType.Place,
                            //    Location = map.VisibleRegion.Center
                            //};
                            //map.Pins.Add(pin);

                            firstMoveIsDone = true;

                            await Task.Delay(1000);
                        });
                    }

                    await MainThread.InvokeOnMainThreadAsync(() =>
                        {
                            //MapSpan mapSpan = MapSpan.FromCenterAndRadius(vm.CurrentLocation,
                            //                           map.VisibleRegion.Radius);
                            MapSpan mapSpan = MapSpan.FromCenterAndRadius(vm.CurrentLocation,
                                   Distance.FromMeters(120));
                            map.MoveToRegion(mapSpan);
                            //map.Pins[0].Location = vm.CurrentLocation;
                        });

                    await Task.Delay(1000);
                }
            }
        });

    }
}